const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const employeeService = require('./employee.service');
const redisClient = require('../../../../redisClient');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

function create(req, res, next) {
    employeeService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function getAll(req, res, next) {
    employeeService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function option(req, res, next) {
    employeeService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function count(req, res, next) {
    employeeService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

function update(req, res, next) {
    employeeService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function enabled(req, res, next) {
    employeeService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function _delete(req, res, next) {
    employeeService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
